// ###########################################################################
// Variables
// ###########################################################################

var m_Window = null;       // Dom::Window
var m_ToolWindows = null;  // Gregor::CToolWindow[]
var m_LastMaxZIndex = 0;   // System::Int32


// ###########################################################################
// Public functions
// ###########################################################################

function initializeToolWindows(wnd)
{
    m_Window = wnd;
    m_Window.document.body.onscroll = handleScroll;
    m_Window.document.body.onmousemove = handleMouseMove;
    m_Window.document.body.onmouseup = handleMouseUp;
    m_Window.document.body.onclick = handleClick;
    m_ToolWindows = new Array();
}

function addToolWindow(sId, sTitle, sTooltip, sGif, sContent, left, top, width)
{
    // already exists?
    var tw = findToolWindow(sId);
    if(tw != null){
        tw.show();
        return tw;
    }
    // create HTML for DIV
    var sHtml = "<div";
    sHtml += " id=\"" + sId + "\"";
    sHtml += " style=\"display: block;";
    sHtml += " position: absolute;";
    sHtml += " left: " + left + "px; top: " + top + "px; width: " + width + "px; height: 50px;";
    sHtml += " margin: 1px; padding: 1px;";
    sHtml += " border-style: solid; border-color: blue; border-width: 2px;";
    sHtml += " background-color: navy; color: white;";
    sHtml += " font-family: Tahoma; font-size: 10pt; font-weight: bold;";
    sHtml += " text-align: center;\"";
    sHtml += " onclick=\"javascript:handleToolWindowClick(this);\"";
    sHtml += ">";
    sHtml += "<div";
    sHtml += " id=\"" + sId + "Title\"";
    sHtml += " style=\"cursor: default;\"";
    sHtml += " onmousedown=\"javascript:handleToolWindowMouseDown(this);\"";
    sHtml += " title=\"" + sTooltip + "\"";
    sHtml += ">";
    sHtml += "<span ondblclick=\"javascript:handleToolWindowGifDoubleClick(this);\"><img border=0 src=\"" + sGif + "\" alt=\"Hide: double click\"></span>&nbsp;";
    sHtml += sTitle;
    sHtml += "<span onclick=\"javascript:handleToolWindowHeightButtonClick(this);\">&nbsp;<img border=0 src=\"minmax.gif\" alt=\"Min/Max\"></span>";
    sHtml += "</div>";
    sHtml += "<div";
    sHtml += " id=\"" + sId + "Inner\"";
    sHtml += " style=\"display: block;";
    sHtml += " font-weight: normal; font-size: 8pt;";
    sHtml += " background-color: #f0f0f0; color: black;\"";
    sHtml += ">";
    sHtml += sContent;
    sHtml += "</div>";
    sHtml += "</div>";
    // add to document
    m_Window.document.body.insertAdjacentHTML("BeforeEnd", sHtml);
    // wrap up in tool window class
    tw = new CToolWindow(sId, sTitle, left, top);
    tw.setActive(true);
    // add to list
    m_ToolWindows[m_ToolWindows.length] = tw;
    // return
    return tw;
}

function findToolWindow(sId)
{
    for(var i = 0; i < m_ToolWindows.length; i++){
        var tw = m_ToolWindows[i];
        if(tw.getId() == sId){
            return tw;
        }
    }
    return null;
}

function getAllToolWindows()
{
    return m_ToolWindows;
}


// ###########################################################################
// Classes
// ###########################################################################

function /* class */ CToolWindow(sId, sTitle, left, top)
{
    // fields
    this.id = sId;
    this.title = sTitle;
    this.lastLeft = left;
    this.lastTop = top;
    this.autoCollapse = false;
    this.dragStarted = false;
    this.dragOffX = 0;
    this.dragOffY = 0;

    // events
    this.onFocus = null;

    // properties
    this.getId = function(){
        return this.id;
    }
    this.getTitle = function(){
        return this.title;
    }
    this.getDiv = function(){
        return m_Window.document.all[this.id];
    }
    this.getContent = function(){
        return this.getDiv().children[this.id + "Inner"];
    }
    this.getLastLeft = function(){
        return this.lastLeft;
    }
    this.getLastTop = function(){
        return this.lastTop;
    }
    this.getAutoCollapse = function(){
        return this.autoCollapse;
    }
    this.setAutoCollapse = function(f){
        this.autoCollapse = f;
    }
    this.isCollapsed = function(){
        with(this.getDiv()){
            return (children[this.id + "Inner"].style.display == "none");
        }
    }
    this.isVisible = function(){
        with(this.getDiv()){
            return (style.display != "none");
        }
    }
    this.hasDragStarted = function(){
        return this.dragStarted;
    }

    // methods
    this.setActive = function(f){
        if(this.getAutoCollapse() && this.isCollapsed() == f){
            this.toggleHeight();
        }
        with(this.getDiv()){
            if(f){
                style.borderColor = "blue";
                style.backgroundColor = "navy";
                if(m_Window.event != null){
                    m_Window.event.cancelBubble = true;
                }
                style.zIndex = getNewMaxZIndex();
                focus();
                if(this.onFocus != null){
                    this.onFocus(this);
                }
            }else{
                style.borderColor = "silver";
                style.backgroundColor = "gray";
            }
        }
    
    }
    this.toggleHeight = function(){
        with(this.getDiv()){
            if(this.isCollapsed()){
                children[this.id + "Inner"].style.display = "block";
                style.pixelHeight = 50;
            }else{
                children[this.id + "Inner"].style.display = "none";
                style.pixelHeight = 20;
            }
        }
    }
    this.move = function(x, y){
        with(this.getDiv()){
            style.left = x;
            style.top = y;
            this.lastLeft = (parseInt(style.left) - m_Window.document.body.scrollLeft);
            this.lastTop = (parseInt(style.top) - m_Window.document.body.scrollTop);
        }
    }
    this.beginDrag = function(offX, offY){
        this.dragOffX = offX;
        this.dragOffY = offY;
        this.dragStarted = true;
        killEvent();
    }
    this.doDrag = function (){
        if(this.dragStarted){
            killEvent();
            var e = m_Window.event;
            if(isPositionedElement(e.srcElement)){
                return;
            }
            var x = e.offsetX - this.dragOffX;
            var y = e.offsetY - this.dragOffY;
            this.move(x, y);
            this.setActive(true);
        }
    }
    this.endDrag = function(){
        this.dragStarted = false;
    }
    this.hide = function(){
        var div = this.getDiv();
        div.style.display = "none";
    }
    this.show = function(){
        var div = this.getDiv();
        div.style.display = "block";
        this.setActive(true);
    }
    this.toString = function(){
        return "CToolWindow ID <" + this.getId() + "> title <" + this.getTitle() + ">";
    }

} // end class CToolWindow


// ###########################################################################
// Internal functions
// ###########################################################################

function scrollToolWindows()
{
    for(var i = 0; i < m_ToolWindows.length; i++){
        var tw = m_ToolWindows[i];
        var div = tw.getDiv();
        div.style.left = m_Window.document.body.scrollLeft + tw.getLastLeft();
        div.style.top = m_Window.document.body.scrollTop + tw.getLastTop();
    }
}

function deactivateAllToolWindows()
{
    for(var i = 0; i < m_ToolWindows.length; i++){
        var tw = m_ToolWindows[i];
        tw.setActive(false);
    }
}

function findDraggedToolWindow()
{
    for(var i = 0; i < m_ToolWindows.length; i++){
        var tw = m_ToolWindows[i];
        if(tw.hasDragStarted()){
            return tw;
        }
    }
    return null;
}

function getNewMaxZIndex()
{
    m_LastMaxZIndex++;
    return m_LastMaxZIndex;
}

function isPositionedElement(elem)
{
    while(elem != null){
        if(elem.style.left != null && elem.style.left != ""){
            return true;
        }
        elem = elem.parentElement;
    }
    return false;
}

function killEvent()
{
    m_Window.event.cancelBubble = true;
    m_Window.event.returnValue = false;
}


// ###########################################################################
// Event handlers (body)
// ###########################################################################

function handleScroll()
{
    scrollToolWindows();
}

function handleMouseMove()
{
    var tw = findDraggedToolWindow();
    if(tw != null){
        tw.doDrag();
    }
}

function handleMouseUp()
{
    var tw = findDraggedToolWindow();
    if(tw != null){
        tw.endDrag();
    }
}

function handleClick()
{
    deactivateAllToolWindows();
}

// ###########################################################################
// Event handlers (tool windows)
// ###########################################################################

function handleToolWindowMouseDown(sender)
{
    var tw = findToolWindow(sender.parentElement.id);
    if(tw != null){
        tw.beginDrag(m_Window.event.offsetX, m_Window.event.offsetY);
    }
}

function handleToolWindowClick(sender)
{
    deactivateAllToolWindows();
    var tw = findToolWindow(sender.id);
    if(tw != null){
        tw.setActive(true);
    }
}

function handleToolWindowGifDoubleClick(sender)
{
    var tw = findToolWindow(sender.parentElement.parentElement.id);
    if(tw != null){
        tw.hide();
    }
}

function handleToolWindowHeightButtonClick(sender)
{
    var tw = findToolWindow(sender.parentElement.parentElement.id);
    if(tw != null){
        tw.toggleHeight();
    }
}